#pragma once

//High velocity used for homing.
//The meaning of this value depends on the homing mode.
#define HOMING_HIGH_VELOCITY 360

//Low velocity used for homing.
//The meaning of this value depends on the homing mode.
#define HOMING_LOW_VELOCITY 36

//Acceleration used while homing.
#define HOMING_ACCELERATION 3600

//Deceleration used while homing.
#define HOMING_DECELERATION 3600

//Direction in which the axis searches for the home.
//Only positive and negative directions are acceptable.
#define HOMING_DIRECTION mcPositiveDirection

//Type of module containing the home sensor.
//TRUE for Axis, FALSE for I/O module.
#define HOME_SENSOR_TYPE FALSE

//Index of the axis/IO module containing the sensor.
#define HOME_SENSOR_INDEX 1

//Offset of the sensor in the module input data.
#define HOME_SENSOR_OFFSET 13

//Invert the home sensor value.
#define HOME_SENSOR_INVERT FALSE

//Home an axis using a probe.
VOID HomingLatch(int Index);

//Home an axis using a sensor.
VOID HomingSoft(int Index);

//Home an axis using a limit switch.
VOID HomingSensor(int Index);

//Home an axis using the CANopen DS402 homing modes in the drive.
VOID HomingSlave(int Index);

//Home an axis using the current position.
VOID HomingOnPosition(int Index);