//////////////////////////////////////////////////////////////////
//
// RT_Project_01_Reader.cpp - cpp file
//
// This file was generated using the RTX64 Application Template for Visual Studio.
//
// Created: 8/23/2021 10:22:21 AM 
// User: test
//
//////////////////////////////////////////////////////////////////

#include "RT_Project_01_Reader.h"
   

int _tmain(int argc, _TCHAR * argv[])
{
     
    //Launch or connect to the KINGSTAR Subsystem process.
    KsError nRet = errNoError;
    nRet = Create(0, 0);
    if (nRet != errNoError)
    {
        RtPrintf("InitializeLink failed: %x\n", nRet);
        return FALSE;
    }

    //Create an instance of the SubsystemStatus structure and get the state from it.
    SubsystemStatus Subsystem = { ecatOffline, ecatOffline, 0, 0, 0, {ecatOffline}, {ecatOffline}, {axisOffline} };
    GetStatus(&Subsystem, NULL);

    //Display the details of the EtherCAT network. These should be the same as RT_Project_01.
    RtPrintf("Number of Devices found: %d\n", Subsystem.SlaveCount);
    RtPrintf("Number of Axes found: %d\n", Subsystem.AxesCount);
    RtPrintf("Number of I/O found: %d\n", Subsystem.IOCount);
    RtPrintf("\n");

    //Declare the same instances of UserVariable in RT_Project_01.
    UserVariable uTemperature = { 0, L"Temperature", NULL, logDouble };
    UserVariable uVoltage = { 0, L"Voltage", NULL, logDouble };
    UserVariable uWarning = { 0, L"Warning", NULL, logBool };
    UserVariable Ready = { 0, L"Ready", NULL, logBool };
    UserVariable Send = { 0, L"Send", NULL, logBool };
    UserVariable uValue1 = { 0, L"Value1", NULL, logDouble };
    UserVariable uValue2 = { 0, L"Value2", NULL, logDouble };
    UserVariable uValue3 = { 0, L"Value3", NULL, logDouble };
    UserVariable uValue4 = { 0, L"Value4", NULL, logDouble };

    //Get the address of the user variables.
    /*In Sender application (RT_Project_01), you don't need to use GetVariable because
      you can get the address of a variable after you use AddVariable. But in Reader
      application (RT_Project_02), you must use GetVariable to access the variable.*/
    GetVariable(&uTemperature);
    GetVariable(&uVoltage);
    GetVariable(&uWarning);
    GetVariable(&uValue1);
    GetVariable(&uValue2);
    GetVariable(&uValue3);
    GetVariable(&uValue4);
    GetVariable(&Ready);
    GetVariable(&Send);

    //By default, we set Ready to TRUE so RT_Project_01 will continue to run.
    *((bool*)Ready.Value) = TRUE;
    *((bool*)Send.Value) = TRUE;

    //Display the logs and their values in Analysis Console.
    //These values are used for demonstration.
    for (int i = 0; i < 3; i++)
    {
        //When Send is TRUE, wait RT_Project_01 to send the data.
        while (*((bool*)Send.Value) == TRUE)
        {
            Sleep(10);
        }

        //When Send is FALSE, receive the data.

        //Send the logs to Analysis Console.
        RtPrintf("DebugMessage %d starts.\n\n", i);

        //Get the values of the first variable and send them to Analysis Console.
        DebugMessage(0, logInfo, L"Melting temperature of metal", TRUE,
            *((double*)uValue1.Value),
            *((double*)uValue2.Value),
            *((double*)uValue3.Value),
            *((double*)uValue4.Value));

        /*After the first variable is sent, wait RT_Project_01 to reset
          uValues to zero, and calculate the values of the second variable.*/
        *((bool*)Send.Value) = TRUE;

        while (*((bool*)Send.Value) == TRUE)
        {
            Sleep(10);
        }

        //Get the values of the second variable and send them to Analysis Console.
        DebugMessage(1, logInfo, L"Voltage of power", TRUE,
            *((double*)uValue1.Value),
            *((double*)uValue2.Value),
            *((double*)uValue3.Value),
            *((double*)uValue4.Value));

        /*After the first variable is sent, wait RT_Project_01 to reset
          uValues to zero, and calculate the values of the third variable.*/
        *((bool*)Send.Value) = TRUE;

        while (*((bool*)Send.Value) == TRUE)
        {
            Sleep(10);
        }

        //Get the values of the third variable and send them to Analysis Console.
        DebugMessage(2, logWarning, L"Warning levels", TRUE,
            *((double*)uValue1.Value),
            *((double*)uValue2.Value),
            *((double*)uValue3.Value),
            *((double*)uValue4.Value));

        //Set Send to TRUE for RT_Project_01 to process the data.
        *((bool*)Send.Value) = TRUE;
    }

    RtPrintf("DebugMessage ends.\n\n");
  
    return 0;
}
