define({"0":{y:0,u:"../Content/KS_4_Tutorial/Introduction.htm",l:-1,t:"Introduction",i:0.000800751448453047,a:"This tutorial aims to teach you how to use the RT/Win32 motion functions in KINGSTAR 4.2. Each chapter contains step-by-step tutorials and sample code to help you learn the motion control capabilities provided by KINGSTAR. The tutorial is a fundamental for people who never or just begin to use ..."},"1":{y:0,u:"../Content/KS_4_Tutorial/How_to_use.htm",l:-1,t:"How to use this tutorial and source code",i:0.000800751448453047,a:"The tutorial contains two folders: Book and Code. Book: contains the KINGSTAR Motion 4.2 tutorial. The home page of the tutorial is KS_Tutorial_4.htm, which can be opened by web browsers. Code: contains the source code used in the tutorial. Double-click RT_Project_01.sln to open the Visual Studio ..."},"2":{y:0,u:"../Content/KS_4_Tutorial/KS_4_Porting.htm",l:-1,t:"KINGSTAR 4 Motion porting information",i:0.000800751448453047,a:"If you have used KINGSTAR 3.x before, you\u0027ll notice that KINGSTAR updates the motion library that breaks the compatibility between version 3.x and 4.x. To clear up the confusion you might have, we list the primary changes KINGSTAR makes in 4.x motion library. The PLCopen and motion board style APIs ..."},"3":{y:0,u:"../Content/KS_4_Tutorial/Release_notes/KS_Tutorial_Release_notes_4.2.htm",l:-1,t:"KINGSTAR 4.2 tutorial release notes",i:0.000800751448453047,a:"What\u0027s new Add  Coordinate transformation  in  Chapter 9 Add  Helical motion  in  Chapter 10 Add  Digital group cam switch  and  Digital cyclic switch  and in  Chapter 12 Add  Chapter 13: Log Add  ReleaseAxis to release a single axis from the  Stopping  state, or detach it from camming and gearing. ..."},"4":{y:0,u:"../Content/KS_4_Tutorial/Ch01_Project_Creation/Ch01_GetStarted.htm",l:-1,t:"Chapter 1: Create an RTX64 Project",i:0.000891908470540905,a:"KINGSTAR provides a motion library that helps you create your own motion application. For developers, they can use RT, Win32, .NET API, .NET Class, and PLC programming languages to create an application. In this tutorial, we demonstrate how to use KINGSTAR API functions in the RT interface. The ..."},"5":{y:0,u:"../Content/KS_4_Tutorial/Ch01_Project_Creation/Prerequisites.htm",l:-1,t:"Prerequisites",i:0.00105345899322891,a:"Before you create a KINGSTAR project, you need to have the following items installed on your computer: KINGSTAR Runtime: used to run your project. KINGSTAR SDK: includes all KINGSTAR APIs. Visual Studio: the integrated development environment used to create your KINGSTAR project. The minimum version ..."},"6":{y:0,u:"../Content/KS_4_Tutorial/Ch01_Project_Creation/RTX64_Project_Creation.htm",l:-1,t:"Create an RTX64 project in Visual Studio",i:0.00109599893686991,a:"To create an RTX64 project in Visual Studio: Start Visual Studio. In Visual Studio, on the File menu, click New \u003e Project. On the Create a new Project page, in the templates list, scroll down to find the RTX64 Application template and select it, and then click Next. In the Configure your new project ..."},"7":{y:0,u:"../Content/KS_4_Tutorial/Ch01_Project_Creation/Rename_Main_Program.htm",l:-1,t:"Rename the main program",i:0.00105345899322891,a:"Before we start the tutorial, we need to rename the main program to main.cpp, which makes it easier for us to know it\u0027s the main program. In Solution Explorer, right-click RT_Project_01.cpp and click Rename. Rename the file to \"main.cpp\" and click Enter. This name makes it clearer which file the ..."},"8":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Ch02_System_Initialization.htm",l:-1,t:"Chapter 2: System Initialization",i:0.00300910890261511,a:"In this chapter, you\u0027ll learn how to initialize an EtherCAT link, configure the settings, start and stop the KINGSTAR Subsystem, and get the EtherCAT states. To write clean code, we create individual files to save the KINGSTAR settings, and integrate them in the main function. Before starting the ..."},"9":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Add_Header_CPP.htm",l:-1,t:"Add a header and .cpp file",i:0.00261521622085542,a:"You need to add a header and a .cpp file to learn the code in a chapter. The following process will be repeated in the following chapters. In Solution Explorer, right-click Source Files and click Add \u003e New Item. In the Add New Item dialog box, in the left pane, click Visual C++. In the middle pane, ..."},"10":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Start_Stop/Configure_Settings.htm",l:-1,t:"Configure the settings",i:0.00115497378248302,a:"KINGSTAR offers a variety of settings that can be configured. To streamline the code, we create individual files for the settings. In this section you\u0027ll learn how to create the files and configure the settings. In Solution Explorer, in the Header Files folder, double-click SystemInitialization.h to ..."},"11":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Start_Stop/Start_Subsystem.htm",l:-1,t:"Start the KINGSTAR Subsystem",i:0.001861292840928,a:"In  Configure the settings , you have learned how to use the variables to configure the KINGSTAR settings in SystemInitialization.h. In this section, you\u0027ll learn how to pass the variables to the functions that configure KINGSTAR settings, and start the KINGSTAR Subsystem. Functions and structures ..."},"12":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/EtherCat_States/EtherCAT_States.htm",l:-1,t:"Get the EtherCAT states",i:0.00103327375021834,a:"When the KINGSTAR Subsystem is being started or after it is started, you need to know the details of an EtherCAT network, the KINGSTAR Subsystem, and EtherCAT slaves. In this section you\u0027ll learn how to use the functions to get their states. The state of an EtherCAT network and the state of the ..."},"13":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/EtherCat_States/EtherCAT_Link.htm",l:-1,t:"The state of an EtherCAT network and the state of the KINGSTAR Subsystem",i:0.00147241544412715,a:"The details of an EtherCAT network and the state of the KINGSTAR Subsystem can be gotten through the  GetStatus function. GetStatus GetStatus gets the details of an EtherCAT network. To use this function, you need to create an instance of the  SubsystemStatus  and  SubsystemDiagnostics  structure, ..."},"14":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/EtherCat_States/EtherCAT_Slave.htm",l:-1,t:"The state of an EtherCAT slave",i:0.00147241544412715,a:"The state of an EtherCAT slave can be gotten through the  GetSlaveById,  GetAxisByIndex, and  GetIOByIndex function and the  SlaveStatus  structure. Functions for SlaveStatus Before you get anything from  SlaveStatus , you need to indicate the device you want to get. GetSlaveById: gets detailed ..."},"15":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Start_Stop/Stop_Subsystem.htm",l:-1,t:"Stop the KINGSTAR Subsystem",i:0.00103327375021834,a:"In  Start the KINGSTAR Subsystem , you have learned how to use the functions to configure the KINGSTAR settings and start the KINGSTAR Subsystem. In this section, you\u0027ll learn how to stop the KINGSTAR Subsystem. Functions and structures In this section, the following functions and structures are ..."},"16":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Ch02_Main.htm",l:-1,t:"Main function",i:0.00103327375021834,a:"In this section, you\u0027ll learn how to apply all the code in this chapter to main.cpp. If everything is done correctly your KINGSTAR Subsystem should be started and stopped properly. To help you review what you have learned, we add comments into the code to describe the meaning of the variables and ..."},"17":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Initialization_Header.htm",l:-1,t:"Subsystem Initialization header",i:0.00107581369385934,a:"This page contains the complete code of the header file in this chapter. In SystemInitialization.h, your code should be as follows: #pragma once\n\n//Using instances other than zero requires a special license.\n#define INSTANCE 0\n\n//Base cycle time for the EtherCAT network.\n//Require the High Speed ..."},"18":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Initialization_CompleteCode.htm",l:-1,t:"Subsystem Initialization complete code",i:0.00103327375021834,a:"This page contains the complete code of Subsystem Initialization. In SystemInitialization.cpp, your Subsystem Initialization code should be as follows: Copy ..."},"19":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/Functions.htm",l:-1,t:"Subsystem Initialization functions",i:0.00103327375021834,a:"Subsystem Initialization functions The following table describes the Subsystem Initialization functions."},"20":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/ConfigureAxis.htm",l:-1,t:"ConfigureAxis",i:0.0011056936622598,a:"Configures the settings of a simulated axis. Syntax KsError ConfigureAxis(\n     int Index,\n     SlaveStatus Details,\n     int Resolution\n); Parameters Index: the index of a simulated axis. Indexes are zero based. Aliases affect this parameter. Details: the  SlaveStatus  structure that contains ..."},"21":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/ConfigureDc.htm",l:-1,t:"ConfigureDc",i:0.00398219224330588,a:"Configures distributed clock (DC) options. Distributed clocks allow the synchronization of the slave cycles with the KINGSTAR cycle. It is highly recommended for any motion application to avoid vibrations. Master Shift: the reference clock is the clock of the first slave on the EtherCAT network. Bus ..."},"22":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/ConfigureIo.htm",l:-1,t:"ConfigureIo",i:0.00140115069691299,a:"Configures the settings of a simulated I/O module. Syntax KsError ConfigureIo(\n     int Index,\n     SlaveStatus Details\n); Parameters Index: the index of a simulated I/O module. Indexes are zero based. Aliases affect this parameter. Details: detailed information about the module. Before using this ..."},"23":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/Create.htm",l:-1,t:"Create",i:0.0164728927157448,a:"Prepares to link a program to the KINGSTAR Subsystem. Syntax KsError Create(\n     int Instance,\n     int IdealProcessor\n); Parameters Instance: selects which KINGSTAR Runtime instance you want to use when you have Multiple Master Package. If you don\u0027t have the package, set it to zero (0). If you ..."},"24":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/Destroy.htm",l:-1,t:"Destroy",i:0.0106966167611408,a:"Closes the link to the KINGSTAR Subsystem and terminates the Subsystem. Syntax KsError Destroy(); Return value If the function succeeds, it returns errNoError, otherwise an error code. For more information about the error code, see the  KsError  list. Remarks Destroy closes the application’s link to ..."},"25":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableActualCurrent.htm",l:-1,t:"EnableActualCurrent",i:0.00146614595324006,a:"Adds the Actual Current variable to PDO. Syntax KsError EnableActualCurrent(\n     BOOL Active\n); Parameters Active: TRUE: the Actual Current variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an error ..."},"26":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableActualTorque.htm",l:-1,t:"EnableActualTorque",i:0.00175077029755808,a:"Adds the Actual Torque variable to PDO. Syntax KsError EnableActualTorque(\n     BOOL Active\n); Parameters Active: TRUE: the Actual Torque variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an error ..."},"27":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableActualVelocity.htm",l:-1,t:"EnableActualVelocity",i:0.00175077029755808,a:"Adds the Actual Velocity variable to PDO. Syntax KsError EnableActualVelocity(\n     BOOL Active\n); Parameters Active: TRUE: the Actual Velocity variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an ..."},"28":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableAutoConfig.htm",l:-1,t:"EnableAutoConfig",i:0.00131951823559631,a:"Allows auto-config to be enabled. It automatically configures the EtherCAT settings for your servo drives. Syntax KsError EnableAutoConfig(\n     BOOL Active\n); Parameters Active: TRUE to enable, and FALSE to disable auto-config. By default, it is TRUE. Return value If the function succeeds, it ..."},"29":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableAutoRepair.htm",l:-1,t:"EnableAutoRepair",i:0.00131951823559631,a:"Allows auto-repair to be enabled. If any slave disappears (due to the replacement of a servo drive, cable disconnection, power cut or other issues) or goes to an EtherCAT error state, it restarts automatically. Slaves that are not in an error state are not impacted and continue to function properly. ..."},"30":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableAutoRestart.htm",l:-1,t:"EnableAutoRestart",i:0.00131951823559631,a:"Allows for auto-restart to be enabled. Following a cable disconnected, if auto-restart is enabled, the EtherCAT master restarts automatically after a cable is plugged in. Syntax KsError EnableAutoRestart(\n     BOOL Active\n); Parameters Active: TRUE to enable, and FALSE to disable auto-restart. By ..."},"31":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableAxisInput.htm",l:-1,t:"EnableAxisInput",i:0.00202835910925786,a:"Adds the Digital Input variable to the PDO. Not all servo drives support this feature. Syntax KsError EnableAxisInput(\n     BOOL Active\n); Parameters Active: TRUE: the Digital Input variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, ..."},"32":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableAxisOutput.htm",l:-1,t:"EnableAxisOutput",i:0.0023967510081195,a:"Adds the Digital Output variable to the PDO. Not all servo drives support this feature. Syntax KsError EnableAxisOutput(\n     BOOL Active\n); Parameters Active: TRUE: the Digital Output variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function ..."},"33":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableFollowingError.htm",l:-1,t:"EnableFollowingError",i:0.00131951823559631,a:"Adds the Following Error variable to PDO. Syntax KsError EnableFollowingError(\n     BOOL Active\n); Parameters Active: TRUE: the Following Error variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an ..."},"34":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableHotConnect.htm",l:-1,t:"EnableHotConnect",i:0.00142106983381046,a:"Allows new hardware to be added while the EtherCAT network is running. Syntax KsError EnableHotConnect(\n     BOOL Active\n); Parameters Active: TRUE to enable, and FALSE to disable Hot Connect. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an error ..."},"35":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableMaxCurrent.htm",l:-1,t:"EnableMaxCurrent",i:0.00131951823559631,a:"Adds the Maximum Current variable to PDO. Syntax KsError EnableMaxCurrent(\n     BOOL Active\n); Parameters Active: TRUE: the Maximum Current variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an error ..."},"36":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableMaxTorque.htm",l:-1,t:"EnableMaxTorque",i:0.00131951823559631,a:"Adds the Max Torque variable to PDO. Syntax KsError EnableMaxTorque(\n     BOOL Active\n); Parameters Active: TRUE: the Maximum Torque variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an error code. ..."},"37":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableRedundancy.htm",l:-1,t:"EnableRedundancy",i:0.0012945592975627,a:"Enables cable redundancy. The last EtherCAT slave is connected to another network interface card on the computer so all the slaves can be communicated even if one cable is broken. Syntax KsError EnableRedundancy(\n     BOOL Active\n); Parameters Active: TRUE to enable, and FALSE to disable redundancy. ..."},"38":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableSecondEncoder.htm",l:-1,t:"EnableSecondEncoder",i:0.00187147899502724,a:"Adds the Internal Position variable to PDO. Syntax KsError EnableSecondEncoder(\n     BOOL Active\n); Parameters Active: TRUE: the Internal Position variable is mapped to PDO. FALSE: not mapped to PDO. By default, it is FALSE. Return value If the function succeeds, it returns errNoError, otherwise an ..."},"39":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableServerLog.htm",l:-1,t:"EnableServerLog",i:0.000870881655072655,a:"Enables the messages of the real-time server on RtxServer. Syntax KsError EnableServerLog(\n     BOOL Active\n); Parameters Active: TRUE to enable, and FALSE to disable displaying messages. By default, it is TRUE. Return value If the function succeeds, it returns errNoError, otherwise an error code. ..."},"40":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/EnableSynchronizedControlMode.htm",l:-1,t:"EnableSynchronizedControlMode",i:0.00263791094570339,a:"Adds the Modes of Operation and Modes of Operation Display variables to PDO. It changes the control mode through PDO instead of SDO, so the control mode can be changed faster (usually in 3-5 cycles). Not all drives support this feature. Syntax KsError EnableSynchronizedControlMode(\n     BOOL ..."},"41":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/GetAxisByIndex.htm",l:-1,t:"GetAxisByIndex",i:0.00254096286764347,a:"Gets information from an axis. Syntax KsError GetAxisByIndex(\n     int Index,\n     SlaveStatus* Details,\n     int* Resolution,\n     DWORD* InputVariables,\n     DWORD* OutputVariables\n); Parameters Index: the index of an axis. Indexes are zero based. Aliases affect this parameter. Details: pointer to ..."},"42":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/GetIOByIndex.htm",l:-1,t:"GetIOByIndex",i:0.00282942316801486,a:"Gets the information from a specified real or simulated I/O module. Syntax KsError GetIOByIndex(\n     int Index,\n     SlaveStatus* Details\n); Parameters Index: the index of the device in the I/O list. Indexes are zero based. Aliases affect this parameter. Details: pointer to the  SlaveStatus  ..."},"43":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/GetSlaveById.htm",l:-1,t:"GetSlaveById",i:0.0025905532801401,a:"Gets detailed information from a specified slave using the ID. Syntax KsError GetSlaveById(\n     int SlaveId,\n     SlaveStatus* Details\n); Parameters SlaveId: the EtherCAT ID of a device. It corresponds to the position of the device in the EtherCAT loop. The ID is zero based and is not affected by ..."},"44":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/GetStatus.htm",l:-1,t:"GetStatus",i:0.00181327997525635,a:"Gets the state of an EtherCAT link. Use this function to see when the link has been established. After the link is established you can access the number of I/O and servo modules. Syntax KsError GetStatus(\n     SubsystemStatus* Status,\n     SubsystemDiagnostics* Diagnostics\n); Parameters Status: ..."},"45":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/SetAxisAccessMode.htm",l:-1,t:"SetAxisAccessMode",i:0.00281841818114469,a:"Sets the data transfer mode for EtherCAT drives. Syntax KsError SetAxisAccessMode(\n     KsAccessMode Mode\n); Parameters Mode: the value of the  KsAccessMode  type to use. Return value If the function succeeds, it returns errNoError, otherwise an error code. For more information about the error code, ..."},"46":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/SetConfiguredAxesCount.htm",l:-1,t:"SetConfiguredAxesCount",i:0.00130586179126523,a:"Configures a number of simulated axes. The number of simulated axes is determined by how much the given value outnumbers the real hardware. If the given number is greater than the number of the real axes, KINGSTAR will display all real axes plus simulated ones. For example, if you have five real ..."},"47":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/SetConfiguredIoCount.htm",l:-1,t:"SetConfiguredIoCount",i:0.00165622767610966,a:"Configures a number of simulated I/O modules. The number of simulated I/Os is determined by how much the given value exceeds the number of the real hardware. If the given number is greater than the number of the real I/Os, KINGSTAR will display all real I/Os plus simulated ones. For example, if you ..."},"48":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/SetCycleTime.htm",l:-1,t:"SetCycleTime",i:0.000870881655072655,a:"Sets the EtherCAT cycle time. Syntax KsError SetCycleTime(\n     double Cycle\n); Parameters Cycle: the interpolation cycle time in second. Return value If the function succeeds, it returns errNoError, otherwise an error code. For more information about the error code, see the  KsError  list. Remarks ..."},"49":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/Start.htm",l:-1,t:"Start",i:0.0219626911636728,a:"Starts the KINGSTAR Subsystem. This starts an EtherCAT network at the same time. Syntax KsCommandStatus Start(); Return value Returns the  KsCommandStatus  structure. Remarks Use this function to start the KINGSTAR Subsystem after initializing and setting the parameters. It has the same effect as ..."},"50":{y:0,u:"../Content/KS_4_Tutorial/Ch02_System_Initialization/Functions/Stop.htm",l:-1,t:"Stop",i:0.0107969878982726,a:"Stops the EtherCAT network and the KINGSTAR Subsystem. Syntax KsCommandStatus Stop(); Return value Returns the  KsCommandStatus  structure. Remarks Use this function after setting all the slaves to their safe position because you can\u0027t access the slaves after stopping the KINGSTAR Subsystem. It has ..."},"51":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Ch03_IO_Control.htm",l:-1,t:"Chapter 3: I/O Control",i:0.00164915964720845,a:"KINGSTAR offers a string of I/O control functions that read or write data into your I/O module in different unit. To access the specific location of the data, you can set the offset. The function\u0027s name indicates the unit of reading, writing, or offsetting data. For example, the unit of  ..."},"52":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/ReadWrite_InputOutput.htm",l:-1,t:"ReadInput, ReadOutput, and WriteOutput",i:0.0010402342888741,a:"In this section, you\u0027ll learn how to use I/O control functions to access a real I/O module. Their uses are similar. The difference is that they read and write different unit of data. Once you know how to use one of them, you know how to use the rest. The process for using I/O control functions ..."},"53":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/ForceInput.htm",l:-1,t:"ForceInput",i:0.00105145509686294,a:"In  ReadInput, ReadOutput, and WriteOutput , you have learned how to read and write data into a real I/O module. In this section, you\u0027ll learn how to use ForceInput to write data into a simulated I/O module and read it. ForceInput functions are for simulated I/O modules only. Because simulated I/O ..."},"54":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Ch03_Main.htm",l:-1,t:"Main function",i:0.000940930128277488,a:"In this section, you\u0027ll learn how to apply all the code in this chapter to main.cpp. If everything is done correctly, you should be able to read and write real and simulated I/O modules. To help you review what you have learned, we add comments into the code to describe the meaning of the functions. ..."},"55":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/IO_Header.htm",l:-1,t:"I/O Control header",i:0.000940930128277488,a:"This page contains the complete code of the header file in this chapter. In IOModule.h, your I/O Control code should be as follows: #pragma once\n\nVOID GetAllInputsOutputs();\nVOID WriteReadOutput(int Index, int Offset, int Value);\nVOID ReadInputOutput(int Index, int Offset);\nVOID ForceInput(int ..."},"56":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/IO_Control_CompleteCode.htm",l:-1,t:"I/O Control complete code",i:0.000940930128277488,a:"This page contains the complete code of  I/O Control . In IOModule.cpp, your I/O Control code should be as follows: Copy ..."},"57":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/Functions.htm",l:-1,t:"I/O Control functions",i:0.000940930128277488,a:"I/O Control functions The following table describes the I/O Control functions. The name of the function ending with the letter \"B\" means the offset unit is byte."},"58":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ForceInputBit.htm",l:-1,t:"ForceInputBit",i:0.00174954284536353,a:"Writes a bit into an input of a simulated I/O module. Syntax KsError ForceInputBit(\n     int Index,\n     int BitOffset,\n     BOOL Value\n); Parameters Index: the index of a simulated I/O module. Indexes are zero based. Aliases affect this parameter. BitOffset: specifies a bit offset to the location ..."},"59":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ForceInputByte.htm",l:-1,t:"ForceInputByte",i:0.00174954284536353,a:"Writes a byte into an input of a simulated I/O module. Syntax KsError ForceInputByte(\n     int Index,\n     int ByteOffset,\n     BYTE Value\n); Parameters Index: the index of a simulated I/O module. Indexes are zero based. Aliases affect this parameter. ByteOffset: specifies a byte offset to the ..."},"60":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ForceInputDWord.htm",l:-1,t:"ForceInputDWord",i:0.00174954284536353,a:"Writes a double word into an input of a simulated I/O module. Syntax KsError ForceInputDWord(\n     int Index,\n     int ByteOffset,\n     DWORD Value\n); Parameters Index: the index of a simulated I/O module. Indexes are zero based. Aliases affect this parameter. ByteOffset: specifies a byte offset to ..."},"61":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ForceInputWord.htm",l:-1,t:"ForceInputWord",i:0.00183441818378439,a:"Writes a word into an input of a simulated I/O module. Syntax KsError ForceInputWord(\n     int Index,\n     int ByteOffset,\n     WORD Value\n); Parameters Index: the index of a simulated I/O module. Indexes are zero based. Aliases affect this parameter. ByteOffset: specifies a byte offset to the ..."},"62":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/GetIOBuffers.htm",l:-1,t:"GetIOBuffers",i:0.000842845717942971,a:"Provides pointers to the input and output buffers of an I/O module. This function is only for RTX64 programs. Syntax KsError GetIOBuffers(\n     int Index,\n     void** InputBuffer,\n     void** OutputBuffer\n); Parameters Index: the index of an I/O module. Indexes are zero based. Aliases affect this ..."},"63":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ReadInputBit.htm",l:-1,t:"ReadInputBit",i:0.00293673881911709,a:"Reads a bit from an input of a real or simulated I/O module. Syntax KsError ReadInputBit(\n     int Index,\n     int BitOffset,\n     BOOL* Value\n); Parameters Index: the index of an I/O module. Indexes are zero based. Aliases affect this parameter. BitOffset: specifies a bit offset to the location to ..."},"64":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ReadInputByte.htm",l:-1,t:"ReadInputByte",i:0.00270766951747453,a:"Reads a byte from an input of a real or simulated I/O module. Syntax KsError ReadInputByte(\n     int Index,\n     int ByteOffset,\n     BYTE* Value\n); Parameters Index: the index of an I/O module. Indexes are zero based. Aliases affect this parameter. ByteOffset: specifies a byte offset to the ..."},"65":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ReadInputDWord.htm",l:-1,t:"ReadInputDWord",i:0.00270766951747453,a:"Reads a double word from an input of a real or simulated I/O module. Syntax KsError ReadInputDWord(\n     int Index,\n     int ByteOffset,\n     DWORD* Value\n); Parameters Index: the index of an I/O module. Indexes are zero based. Aliases affect this parameter. ByteOffset: specifies a byte offset to ..."},"66":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ReadInputWord.htm",l:-1,t:"ReadInputWord",i:0.00279840427534085,a:"Reads a word from an input of a real or simulated I/O module. Syntax KsError ReadInputWord(\n     int Index,\n     int ByteOffset,\n     WORD* Value\n); Parameters Index: the index of an I/O module. Indexes are zero based. Aliases affect this parameter. ByteOffset: specifies a byte offset to the ..."},"67":{y:0,u:"../Content/KS_4_Tutorial/Ch03_IO_Control/Functions/ReadIOAlias.htm",l:-1,t:"ReadIOAlias",i:0.00146581969015489,a:"Reads the alias index from a real or simulated I/O module. Syntax KsError ReadIOAlias(\n     int Index,\n     int* Alias\n); Parameters Index: the index of an I/O module. Indexes are zero based. Aliases affect this parameter. Alias: pointer to the value to receive the alias index. Return value If the ..."},});